using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Net;
using CleverComponents.InetSuite;
using CleverComponents.InetSuite.Sspi;

namespace ClientSSL
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btnUpload;
		private System.Windows.Forms.TextBox edtHost;
		private System.Windows.Forms.TextBox edtPort;
		private System.Windows.Forms.TextBox edtFile;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.edtHost = new System.Windows.Forms.TextBox();
			this.edtPort = new System.Windows.Forms.TextBox();
			this.edtFile = new System.Windows.Forms.TextBox();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.btnUpload = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Host";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 23);
			this.label2.TabIndex = 1;
			this.label2.Text = "Port";
			// 
			// edtHost
			// 
			this.edtHost.Location = new System.Drawing.Point(72, 16);
			this.edtHost.Name = "edtHost";
			this.edtHost.Size = new System.Drawing.Size(264, 20);
			this.edtHost.TabIndex = 2;
			this.edtHost.Text = "localhost";
			// 
			// edtPort
			// 
			this.edtPort.Location = new System.Drawing.Point(72, 40);
			this.edtPort.Name = "edtPort";
			this.edtPort.Size = new System.Drawing.Size(64, 20);
			this.edtPort.TabIndex = 3;
			this.edtPort.Text = "9001";
			// 
			// edtFile
			// 
			this.edtFile.Location = new System.Drawing.Point(72, 72);
			this.edtFile.Name = "edtFile";
			this.edtFile.Size = new System.Drawing.Size(224, 20);
			this.edtFile.TabIndex = 6;
			this.edtFile.Text = "";
			// 
			// btnBrowse
			// 
			this.btnBrowse.Location = new System.Drawing.Point(312, 72);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(24, 23);
			this.btnBrowse.TabIndex = 7;
			this.btnBrowse.Text = "...";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// btnUpload
			// 
			this.btnUpload.Location = new System.Drawing.Point(224, 112);
			this.btnUpload.Name = "btnUpload";
			this.btnUpload.Size = new System.Drawing.Size(112, 23);
			this.btnUpload.TabIndex = 8;
			this.btnUpload.Text = "Upload";
			this.btnUpload.Click += new System.EventHandler(this.btnUpload_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 72);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 23);
			this.label3.TabIndex = 9;
			this.label3.Text = "File Name";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(352, 166);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.btnUpload);
			this.Controls.Add(this.btnBrowse);
			this.Controls.Add(this.edtFile);
			this.Controls.Add(this.edtPort);
			this.Controls.Add(this.edtHost);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "Form1";
			this.Text = "Client SSL";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(new ExceptionHandler().OnThreadException);
			Application.Run(new Form1());
		}

		private void btnBrowse_Click(object sender, System.EventArgs e) {
			if(openFileDialog1.ShowDialog() == DialogResult.OK) {
				edtFile.Text = openFileDialog1.FileName;
			}
		}

		private void btnUpload_Click(object sender, System.EventArgs e) {
			using(Stream stream = new FileStream(edtFile.Text, FileMode.Open, FileAccess.Read)) {
				UploadData(stream, edtHost.Text, Convert.ToInt32(edtPort.Text));

				MessageBox.Show(String.Format("File {0} ({1} bytes) was uploaded successfully.",
					edtFile.Text, stream.Length));
			}
		}

		private void UploadData(Stream stream, string host, int port) {
			using(TcpClientConnection client = new TcpClientConnection()) {
				//assigns TLS stream
				TlsNetworkStream tlsStream = new TlsNetworkStream();
				client.NetworkStream = tlsStream;

				//is necessary when using self-signed certificate by server
				tlsStream.CertificateFlags = CertificateVerifyFlags.IgnoreCommonNameInvalid
					| CertificateVerifyFlags.IgnoreUnknownAuthority;

				//specifies TLS 1.0 protocols (also available SSL 2.0 and SSL 3.0)
				tlsStream.TlsFlags = TlsFlags.UseTLS;

				//is used for verifying server certificate
				tlsStream.TargetName = host;

				client.TimeOut = 10000;
				IPAddress ip = HostResolver.GetIPAddress(host);

				client.Open(ip, port);
				client.WriteData(stream);
				client.Close(true);
			}
		}
	}

	public class ExceptionHandler {
		public void OnThreadException(object sender, System.Threading.ThreadExceptionEventArgs t) {
			MessageBox.Show(t.Exception.Message);
		}
	}
}
