using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Net;
using CleverComponents.InetSuite;
using CleverComponents.InetSuite.Sspi;

namespace ServerSSL
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox edtPort;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox memLog;
		private System.Windows.Forms.Button btnAccept;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button btnBrowse;
		private System.Windows.Forms.TextBox edtFile;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private CleverComponents.InetSuite.CertificateStore certificateStore1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.edtPort = new System.Windows.Forms.TextBox();
			this.btnAccept = new System.Windows.Forms.Button();
			this.memLog = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.edtFile = new System.Windows.Forms.TextBox();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.certificateStore1 = new CleverComponents.InetSuite.CertificateStore();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 0;
			this.label1.Text = "Port";
			// 
			// edtPort
			// 
			this.edtPort.Location = new System.Drawing.Point(72, 16);
			this.edtPort.Name = "edtPort";
			this.edtPort.Size = new System.Drawing.Size(72, 20);
			this.edtPort.TabIndex = 1;
			this.edtPort.Text = "9001";
			// 
			// btnAccept
			// 
			this.btnAccept.Location = new System.Drawing.Point(216, 80);
			this.btnAccept.Name = "btnAccept";
			this.btnAccept.Size = new System.Drawing.Size(112, 23);
			this.btnAccept.TabIndex = 12;
			this.btnAccept.Text = "Accept Data";
			this.btnAccept.Click += new System.EventHandler(this.btnAccept_Click);
			// 
			// memLog
			// 
			this.memLog.Location = new System.Drawing.Point(0, 120);
			this.memLog.Multiline = true;
			this.memLog.Name = "memLog";
			this.memLog.ReadOnly = true;
			this.memLog.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.memLog.Size = new System.Drawing.Size(344, 176);
			this.memLog.TabIndex = 13;
			this.memLog.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 96);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 23);
			this.label2.TabIndex = 5;
			this.label2.Text = "Log";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 48);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 23);
			this.label3.TabIndex = 3;
			this.label3.Text = "File Name";
			// 
			// btnBrowse
			// 
			this.btnBrowse.Location = new System.Drawing.Point(304, 48);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(24, 23);
			this.btnBrowse.TabIndex = 11;
			this.btnBrowse.Text = "...";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// edtFile
			// 
			this.edtFile.Location = new System.Drawing.Point(72, 48);
			this.edtFile.Name = "edtFile";
			this.edtFile.Size = new System.Drawing.Size(224, 20);
			this.edtFile.TabIndex = 10;
			this.edtFile.Text = "uploaded_file.dat";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(338, 294);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.btnBrowse);
			this.Controls.Add(this.edtFile);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.memLog);
			this.Controls.Add(this.btnAccept);
			this.Controls.Add(this.edtPort);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "Form1";
			this.Text = "Server SSL";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(new ExceptionHandler().OnThreadException);
			Application.Run(new Form1());
		}

		private void btnBrowse_Click(object sender, System.EventArgs e) {
			if(saveFileDialog1.ShowDialog() == DialogResult.OK) {
				edtFile.Text = saveFileDialog1.FileName;
			}
		}

		private void btnAccept_Click(object sender, System.EventArgs e) {
			using(FileStream stream = new FileStream(edtFile.Text, FileMode.Create, FileAccess.Write)) {
				AcceptData(stream, Convert.ToInt32(edtPort.Text));

				string msg = String.Format("File {0} ({1} bytes) was received successfully.",
					edtFile.Text, stream.Length);
				MessageBox.Show(msg);
				memLog.Text += msg + "\r\n";
			}
		}

		private void AcceptData(Stream stream, int port) {
			using(TcpServerConnection server = new TcpServerConnection()) {
				//assigns TLS stream
				TlsNetworkStream tlsStream = new TlsNetworkStream();
				server.NetworkStream = tlsStream;

				//the time-out interval never elapses
				server.TimeOut = -1;

				//read until disconnected from the remote peer
				server.IsReadUntilClose = true;

				//specifies TLS 1.0 protocols (also available SSL 2.0 and SSL 3.0)
				tlsStream.TlsFlags = TlsFlags.UseTLS;

				//used for loading server certificate
				tlsStream.GetCertificate += new GetCertificateEventHandler(GetServerCertificate);
				
				server.Open(port);
				server.Accept();

				server.ReadData(stream);

				server.Close(false);
			}
		}

		private void GetServerCertificate(object sender, GetCertificateEventArgs e) {
			//creates self-signed server certificate
			if(certificateStore1.Items.Count == 0) {
				certificateStore1.ValidFrom = DateTime.Now;
				certificateStore1.ValidTo = DateTime.Now.AddYears(1);
				Certificate cert = certificateStore1.CreateSelfSigned("CN=CleverTester,O=CleverComponents,E=CleverTester@company.mail",	0);
				certificateStore1.Items.Add(cert);
			}
			e.Certificate = certificateStore1.Items[0];
			e.Handled = true;
		}
	}

	public class ExceptionHandler {
		public void OnThreadException(object sender, System.Threading.ThreadExceptionEventArgs t) {
			MessageBox.Show(t.Exception.Message);
		}
	}
}
